BEGIN {
   tmr_debug = 0;
   tentry = 0.0;
   tdocs = 0.0;
   tpgs = 0.0;
   tbytes = 0.0;
   tsecs = 0.0;
   twal = 0.0;
   twalio = 0.0;
   tio = 0.0;
   days = 18.0;
   day = 60.0 * 60.0 * days;
   for (i = 0.0; i <= 8; i++) {
      tot_tsecs[i] = 0.0;
      tot_wks[i] = 0.0;
      tot_days[i] = 0.0;
      tot_hrs[i] = 0.0;
      tot_mins[i] = 0.0;
      tot_secs[i] = 0.0;
      sds_secs[i] = 0.0;
   }
   ln1 = "---------------------------------------";
   ln_str = sprintf ("%s%s", ln1, ln1);
   errcnt = 0.0;
   sds_cnt = 0.0;
}
(($1 == "SDS") ||
 ($1 == "EMC")) {
   if (NF >= 15) {
      io = ($5 * 3600.0 * 24.0 * 365.0) + \
	   ($7 * 3600.0 * 24.0 * 7.0) + \
	   ($9 * 3600.0 * 24.0) + \
	   ($11 * 3600.0) + \
	   ($13 * 60.0) + \
	   ($15 * 1.0);
   } else if (NF >= 13) {
      io = ($5 * 3600.0 * 24.0 * 7.0) + \
	   ($7 * 3600.0 * 24.0) + \
	   ($9 * 3600.0) + \
	   ($11 * 60.0) + \
	   ($13 * 1.0);
   } else if (NF >= 11) {
      io = ($5 * 3600.0 * 24.0) + \
	   ($7 * 3600.0) + \
	   ($9 * 60.0) + \
	   ($11 * 1.0);
   } else if (NF >= 9) {
      io = ($5 * 3600.0) + \
	   ($7 * 60.0) + \
	   ($9 * 1.0);
   } else if (NF >= 7) {
      io = ($5 * 60.0) + \
	   ($7 * 1.0);
   } else if (NF >= 5) {
      io  = ($5 * 1.0);
   }
   if ($2 == "Pool") {
      sds_cnt++;
      i = 0;
   } else if ($2 == "Clip") {
      i = 1;
   } else if ($2 == "Tag") {
      i = 2;
   } else if ($2 == "Blob") {
      i = 3;
   }
   if (tmr_debug) printf("EMC %s [ %f + %f = ", $2, sds_secs[i], io);
   sds_secs[i] += io;
   if (tmr_debug) printf ("%f ]\n", sds_secs[i]);
}
($1 == "---") {
   errcnt++;
}
($5 == "TMR:") {
   if (tmr_debug) print $0;
   tdocs++;
   tsecs += $8;
}
($1 == "TMR:Child") {
   if (tmr_debug) print $0;
   docs = $3;
   pgs = $5;
   if ($8 == "KByts") {
      bytes = $7 * 1024.0;
   } else {
      bytes = $7;
   }
   secs = ($10 > 0) ? $10 : 0;
   wal = ($12 > 0) ? $12 : 0;
   walio = ($14 > 0) ? $14 : 0;
   if (NF >= 26) {
      io = ($16 * 3600.0 * 24.0 * 365.0) + \
	   ($18 * 3600.0 * 24.0 * 7.0) + \
	   ($20 * 3600.0 * 24.0) + \
	   ($22 * 3600.0) + \
	   ($24 * 60.0) + \
	   ($26 * 1.0);
   } else if (NF >= 24) {
      io = ($16 * 3600.0 * 24.0 * 7.0) + \
	   ($18 * 3600.0 * 24.0) + \
	   ($20 * 3600.0) + \
	   ($22 * 60.0) + \
	   ($24 * 1.0);
   } else if (NF >= 22) {
      io = ($16 * 3600.0 * 24.0) + \
	   ($18 * 3600.0) + \
	   ($20 * 60.0) + \
	   ($22 * 1.0);
   } else if (NF >= 20) {
      io = ($16 * 3600.0) + \
	   ($18 * 60.0) + \
	   ($20 * 1.0);
   } else if (NF >= 18) {
      io = ($16 * 60.0) + \
	   ($18 * 1.0);
   } else if (NF >= 16) {
      io = ($16 * 1.0);
   }
   if (tmr_debug)
       printf ("\tTot=%f, Wal=%f, WalIo=%f, Io=%f\n", secs, wal, walio, io);
   if (secs < (wal + walio + io)) {
      secs += (wal + walio + io);
   }
   if (!secs) {
      secs = 1;
   }
   if (tmr_debug)
       printf ("\tTot=%f, Wal=%f, WalIo=%f, Io=%f\n", secs, wal, walio, io);
   if ($17 == "Ent") {
      tentry += $18;
   }
   if (docs) {
      ds = docs / secs;
      ps = pgs / secs;
      if (bytes < 1024.0) {
	 bs = bytes / secs;
	 btag = " b";
      } else if (bytes < (1024.0 * 1024.0)) {
	 bs = (bytes / 1024.0) / secs;
	 btag = "Kb";
      } else {
	 bs = (bytes / (1024.0 * 1024.0)) / secs;
	 btag = "Mb";
      }
      ts = sprintf ("%d", ps * day);
      fl = length (ts) + 1;
      if (tmr_debug)
	  printf ("\tPerDay %*d Docs. %*d Pgs. %*.2f %s\n", \
		  fl, ds * day, fl, ps * day, fl + 3, bs * day, btag);
      tdocs += docs;
      tpgs += pgs;
   }
   if (tmr_debug) printf("tsecs  [ %f + %f = ", tsecs, secs);
   tsecs += secs;
   if (tmr_debug) printf ("%f ]\n", tsecs);
   if (tmr_debug) printf("tbytes [ %f + %f = ", tbytes, bytes);
   tbytes += bytes;
   if (tmr_debug) printf ("%f ]\n", tbytes)
   if (tmr_debug) printf("twal   [ %f + %f = ", twal, wal);
   twal += wal;
   if (tmr_debug) printf ("%f ]\n", twal)
   if (tmr_debug) printf("twalio [ %f + %f = ", twalio, walio);
   twalio += walio;
   if (tmr_debug) printf ("%f ]\n", twalio);
   if (tmr_debug) printf("tio    [ %f + %f = ", tio, io);
   tio += io;
   if (tmr_debug) printf ("%f ]\n", tio);
}
($2 == "Time") {
   if ($1 == "Total") {
      i = 0;
   } else if ($1 == "Sleep") {
      i = 1;
   } else if ($1 == "Query") {
      i = 2;
   } else {
      i = 4;
   }
   if (NF >= 13) {
      tot_days[i] += ($(NF - 9) * 7);
   }
   if (NF >= 11) {
      tot_days[i] += $(NF - 7);
   }
   if (NF >= 9) {
      tot_hrs[i] += $(NF - 5);
   }
   if (NF >= 7) {
      tot_mins[i] += $(NF - 3);
   }
   if (NF >= 5) {
      tot_secs[i] += $(NF - 1);
   }
   tot_tsecs[i] = (tot_days[i] * 24.0 * 3600.0) + \
		  (tot_hrs[i] * 3600.0) + (tot_mins[i] * 60.0) + tot_secs[i];
}
END {
   printf ("%s\n", ln_str);
   if (!tdocs) {
      printf ("\tNo Items Were Processed OR Timing Wasn't Turned On!\n");
   } else {
      ts = sprintf ("%d", tpgs);
      fl = length (ts) + 1;
      printf ("   Total Documents : %*d\n", fl, tdocs);
      printf ("         Pages     : %*d\n", fl, tpgs);
      if (tbytes < 1024.0) {
	 bps = tbytes;
	 btag = "Bytes";
      } else if (tbytes < (1024.0 * 1024.0)) {
	 bps = tbytes / 1024.0;
	 btag = "KBytes";
      } else {
	 bps = tbytes / (1024.0 * 1024.0);
	 btag = "MBytes";
      }
      printf ("         %-*s : %*d\n", length ("Documents"), btag, fl, bps);
      if (errcnt) {
	 printf ("         Errors    : %*d\n", fl, errcnt);
      }
      secs = tot_tsecs[1] + tot_tsecs[2] + tot_tsecs[4] + \
	     tot_tsecs[5] + tot_tsecs[6];
      if (tmr_debug) printf("tsecs  [ %f + %f = ", tsecs, secs);
      tsecs += secs;
      if (tmr_debug) printf ("%f ]\n", tsecs);
      if (tsecs > (7.0 * 24.0 * 3600.0)) {
	 doit = 5;
      } else if (tsecs > (24.0 * 3600.0)) {
	 doit = 4;
      } else if (tsecs > 3600.0) {
	 doit = 3;
      } else if (tsecs > 60.0) {
	 doit = 2;
      } else {
	 doit = 1;
      }
      printf ("%s\n", ln_str);
      sds_secs[4] = sds_secs[0] + sds_secs[1] + sds_secs[2] + sds_secs[3];
      if (sds_secs[4]) {
         for (i=0; i <=4; i++) {
	    if (i == 0) {
	       et = "Pool ";
	    } else if (i == 1) {
	       et = "Clip ";
	    } else if (i == 2) {
	       et = "Tag  ";
	    } else if (i == 3) {
	       et = "Blob ";
	    } else if (i == 4) {
	       et = "Total";
	    }
	    secs = sds_secs[i];
	    p = secs - int (secs);
            f = 7.0 * 24.0 * 3600.0;
	    if (secs > f) {     
	       w = secs / f;    
	       l = secs % f;    
	    } else {            
	       w = 0;           
	       l = secs;        
	    }                   
	    max_secs = l;       
            f = 24.0 * 3600.0;
	    if (max_secs > f) {     
	       d = max_secs / f;    
	       l = max_secs % f;    
	    } else {            
	       d = 0;           
	       l = max_secs;        
	    }                   
	    max_secs = l;       
            f = 3600.0;
	    if (max_secs > f) {     
	       h = max_secs / f;    
	       l = max_secs % f;    
	    } else {            
	       h = 0;           
	       l = max_secs;        
	    }                   
	    max_secs = l;       
            f = 60.0;
	    if (max_secs > f) {     
	       m = max_secs / f;    
	       l = max_secs % f;    
	    } else {            
	       m = 0;           
	       l = max_secs;        
	    }                   
	    s = (l % 60.0) + p;
	    printf ("  SDS Time - %s : ", et)
	    if ((doit >= 5) || (w > .99)) {
	       printf ("%2d weeks, ", w);
	    }
	    if ((doit >= 4) || (d > .99)) {
	       printf ("%2d days, ", d);
	    }
	    if ((doit >= 3) || (h > .99)) {
	       printf ("%2d hrs, ", h);
	    }
	    if ((doit >= 2) || (m > .99)) {
	       printf ("%2d mins, ", m);
	    }
	    if ((doit >= 1) || (s > .01)) {
	       printf ("%5.2f secs", s);
	    }
	    printf ("\n");
         }
	 printf ("  SDS Processes    : %d\n%s\n", sds_cnt, ln_str);
      }
      for (i = 6; i >= 0; i--) {
	 max_secs = tot_tsecs[i];
	 if (i == 0) {
	    type = et;
	 } else if (i == 1) {
	    type = "     Sleep";
	    if (max_secs < 0) {
	       max_secs = tsecs - (tot_tsecs[1] + tot_tsecs[2]);
	       et = "Est Elapse";
	    } else {
	       et = "    Elapse";
	    }
	 } else if (i == 2) {
	    type = "     Query";
	 } else if (i == 3) {
	    type = "  OverHead";
	 } else if (i == 4) {
	    type = "Non IO WAL";
	    max_secs = twal;
	 } else if (i == 5) {
	    type = "    IO WAL";
	    max_secs = twalio;
	 } else if (i == 6) {
	    type = "    Std IO";
	    max_secs = tio;
	 }
	 tot_tsecs[i] = max_secs;
	 if (tmr_debug) printf ("[%3d] '%s' = %f\n", i, type, max_secs);
	 if (tmr_debug) printf ("      '%s' = %f\n", type, tot_tsecs[i]);
	 p = max_secs - int (max_secs);
	 f = 7.0 * 24.0 * 3600.0;
	 if (max_secs > f) {     
	    tot_wks[i] = max_secs / f;    
	    l = max_secs % f;    
	 } else {            
	    tot_wks[i] = 0;           
	    l = max_secs;        
	 }                   
	 f = 24.0 * 3600.0;
	 if (max_secs > f) {     
	    tot_days[i] = max_secs / f;    
	    l = max_secs % f;    
	 } else {            
	    tot_days[i] = 0;           
	    l = max_secs;        
	 }                   
	 max_secs = l;
	 f = 3600.0;
	 if (max_secs > f) {     
	    tot_hrs[i] = max_secs / f;    
	    l = max_secs % f;    
	 } else {            
	    tot_hrs[i] = 0;           
	    l = max_secs;        
	 }                   
	 max_secs = l;
	 f = 60.0;
	 if (max_secs > f) {     
	    tot_mins[i] = max_secs / f;    
	    l = max_secs % f;    
	 } else {            
	    tot_mins[i] = 0;           
	    l = max_secs;        
	 }                   
	 tot_secs[i] = (l % 60.0) + p;
	 if (i <= 0) {
	    printf ("%s\n", ln_str);
	 }
	 if (tot_wks[i] || tot_days[i] || tot_hrs[i] || \
	     tot_mis[i] || tot_secs[i]) {
	    printf ("   %s Time : ", type);
	    if ((doit >= 5) || (tot_wks[i] > .99)) {
	       printf ("%2d weeks, ", tot_wks[i]);
	    }
	    if ((doit >= 4) || (tot_days[i] > .99)) {
	       printf ("%2d days, ", tot_days[i]);
	    }
	    if ((doit >= 3) || (tot_hrs[i] > .99)) {
	       printf ("%2d hrs, ", tot_hrs[i]);
	    }
	    if ((doit >= 2) || (tot_mins[i] > .99)) {
	       printf ("%2d mins, ", tot_mins[i]);
	    }
	    if ((doit >= 1) || (tot_secs[i] > .01)) {
	       printf ("%5.2f secs", tot_secs[i]);
	    }
	    printf ("\n");
	 }
	 if (i == 4) {
	    secs = tot_tsecs[1] + tot_tsecs[2] + tot_tsecs[4] + \
		   tot_tsecs[5] + tot_tsecs[6];
	    if (tmr_debug) printf ("  Active process= %f\n", secs);
	    if (tot_tsecs[0] > secs) {
	       tot_tsecs[3] = tot_tsecs[0] - secs;
	    } else {
	       tot_tsecs[3] = 0;
	    }
	 } else if (i == 3) {
	    secs = tot_tsecs[1] + tot_tsecs[2];
	    if (tmr_debug) printf ("InActive process= %f\n", secs);
	    if (tot_tsecs[0] > secs) {
               tsecs = tot_tsecs[0] - secs;
	    } else {
	       tsecs = tot_tsecs[4] + tot_tsecs[5] + tot_tsecs[6];
	    }
	    if (tmr_debug) printf ("[T] '   Process' = %f\n", tsecs);
	    p = tsecs - int (tsecs);
            f = 7.0 * 24.0 * 3600.0;
	    if (tsecs > f) {     
	       w = tsecs / f;    
	       l = tsecs % f;    
	    } else {            
	       w = 0;           
	       l = tsecs;        
	    }                   
	    max_secs = l;       
            f = 24.0 * 3600.0;
	    if (max_secs > f) {     
	       d = max_secs / f;    
	       l = max_secs % f;    
	    } else {            
	       d = 0;           
	       l = max_secs;        
	    }                   
	    max_secs = l;       
            f = 3600.0;
	    if (max_secs > f) {     
	       h = max_secs / f;    
	       l = max_secs % f;    
	    } else {            
	       h = 0;           
	       l = max_secs;        
	    }                   
	    max_secs = l;       
            f = 60.0;
	    if (max_secs > f) {     
	       m = max_secs / f;    
	       l = max_secs % f;    
	    } else {            
	       m = 0;           
	       l = max_secs;        
	    }                   
	    s = (l % 60.0) + p;
	    printf ("%s\n", ln_str);
	    printf ("Total Process Time : ")
	    if ((doit >= 5) || (w > .99)) {
	       printf ("%2d weeks, ", w);
	    }
	    if ((doit >= 4) || (d > .99)) {
	       printf ("%2d days, ", d);
	    }
	    if ((doit >= 3) || (h > .99)) {
	       printf ("%2d hrs, ", h);
	    }
	    if ((doit >= 2) || (m > .99)) {
	       printf ("%2d mins, ", m);
	    }
	    if ((doit >= 1) || (s > .01)) {
	       printf ("%5.2f secs", s);
	    }
	    printf ("\n");
	 }
      }
      spd = (tsecs * 1.0) / (tdocs * 1.0);
      h = spd / 3600;
      l = spd % 3600.0;
      m = l / 60;
      s = l % 60.0;
      if ((s <.01) || (m < .99) || (h < .99)) {
	 s = spd;
      }
      printf ("%s\n", ln_str);
      printf ("       PerDoc Time : %2d hrs, %2d mins, %5.2f secs\n", h, m, s);
      printf ("Daily Rates (%5.2f hour day):\n", days);
      if (tbytes < 1024.0) {
	 bps = tbytes / tsecs;
	 btag = "Bytes";
      } else if (tbytes < (1024.0 * 1024.0)) {
	 bps = (tbytes / 1024.0) / tsecs;
	 btag = "KBytes";
      } else {
	 bps = (tbytes / (1024.0 * 1024.0)) / tsecs;
	 btag = "MBytes";
      }
      ts = sprintf ("%d", bps * day);
      fl = length (ts) + 4;
      dps = (tdocs / tsecs);
      pps = (tpgs / tsecs);
      ts = sprintf ("%d", pps * day);
      if ((length (ts) + 4) > fl) {
	 fl = length (ts) + 4;
      }
      printf ("\tDocs  %*.2f/sec%*.2f/min%*.2f/hr%*.2f/day\n", \
	      fl, dps, fl, dps * 60.0, fl, dps * 3600.0, fl, dps * day);
      printf ("\tPages %*.2f/sec%*.2f/min%*.2f/hr%*.2f/day\n", \
	      fl, pps, fl, pps * 60.0, fl, pps * 3600.0, fl, pps * day);
      printf ("\t%s% *.2f/sec%*.2f/min%*.2f/hr%*.2f/day\n", \
	    btag, fl, bps, fl, bps * 60.0, fl, bps * 3600.0, fl, bps * day);
      if (tentry) {
	 spd = tentry / tdocs;
	 a1 = spd / 3600;
	 a2 = spd % 3600.0;
	 a3 = a2 / 60;
	 a4 = a2 % 60.0;
	 printf ("\tAverage Document Q-wait was %2d hrs %2d mins %5.2 secs\n", \
		 a1, a3, a4);
      }
      printf ("%s\n", ln_str);
   }
}
